Subject: Re: bug#52324: 29.0.50; "Padded" mode line lacks uniform border

From: Eli Zaretskii <[email-masked]>
Date: Mon, 06 Dec 2021 16:47:17 +0200

> From: Protesilaos Stavrou <[email-masked]>
> Date: Mon, 06 Dec 2021 10:58:02 +0200
> 
> In an emacs -Q session with version 27 we could evaluate the following
> to make the mode line look more spacious ("padded", so to speak):
> 
>     (setq x-underline-at-descent-line t)
> 
>     (set-face-attribute 'mode-line nil
>                         :foreground "black"
>                         :background "gray80"
>                         :box '(:line-width 6 :color "gray80")
>                         :overline "gray30"
>                         :underline "gray30"
>                         :distant-foreground 'unspecified)
> 
> Whereas with master, the same results in a box with interrupted lines.

This seems to be a general bug regarding display of stretches of
whitespace with overline and underline.  In Emacs 27, after evaluating
the above settings, try this:

   M-: (setq mode-line-format "%b		%p HELLO") RET

where the whitespace between %b and %p is 2 TAB characters.  you will
see that the stretch glyph produced for the TABs lacks the overline
and underline in Emacs 27 as well.

So this is not a bug introduced by the recent changes in the mode
line, it is a bug that was always in Emacs, and those recent changes
just exposed it.

I'll try to dig into this when I have time.

> Furthermore, there exists an invisible button (?) to the left of the
> "All" text.  The emacs-29-mode-line-padded-mouse-pointer-button.png
> shows it and also captures the tooltip.  (Maybe these are related to the
> same underlying change on how the mode line is produced, otherwise I can
> file a separate bug report).

I think that's a separate bug, so please file a separate report for
it.

Thanks.